frontend/main/forms/professor_form.py
# - *- coding: utf- 8 - *-
from flask_wtf import FlaskForm #Importa funciones de formulario
from wtforms import PasswordField, SubmitField, StringField #Importa campos
from wtforms.fields.html5 import EmailField #Importa campos HTML
from wtforms import validators #Importa validaciones

class ProfessorForm(FlaskForm):

    #Definición de campo String
    firstname = StringField('Firstname',
    [
        #Definición de validaciones
        validators.Required(message = "Firstname is required")
    ])

    lastname = StringField('Lastname',
    [
        validators.Required(message = "Lastname is required")
    ])

    #Definición de campo de mail
    email = EmailField('E-mail',
    [
        validators.Required(message = "E-mail is require"),
        validators.Email( message ='Formad not valid'),
    ])

    #Definición de campo de contraseña
    password = PasswordField('Password', [
        validators.Required(),
         #El campo de contraseña debe coincidir con el de confirmuar
        validators.EqualTo('confirm', message='Passwords dont match')
    ])

    confirm = PasswordField('Repeat Password')

    #Definición de campo submit
    submit = SubmitField("Send")

frontend/main/forms/project_form.py
# - *- coding: utf- 8 - *-
from flask_wtf import FlaskForm #Importa funciones de formulario
from wtforms import PasswordField, SubmitField, StringField, SelectField, HiddenField#Importa campos
from wtforms.fields.html5 import EmailField, DateTimeField #Importa campos HTML
from wtforms import validators #Importa validaciones

class ProjectFilterForm(FlaskForm):

    name = StringField('Name', [validators.optional()])
    yearFrom = DateTimeField('From year', [validators.optional()],format='%Y',)
    yearTo = DateTimeField('To year', [validators.optional()],format='%Y',)
    professorId = SelectField('Professor',[validators.optional()], coerce=int,)
    submit = SubmitField("Filter")
    download = SubmitField("Download")

class ProjectForm(FlaskForm):

    #Definición de campo String
    name = StringField('Name',
    [
        #Definición de validaciones
        validators.Required(message = "Name is required")
    ])

    year = DateTimeField('Year', format='%Y')

    professorId = SelectField('Professor', coerce=int)
    #Definición de campo submit
    submit = SubmitField("Send")

frontend/main/routes/main.py
from flask import Blueprint, redirect, url_for, current_app, request, make_response, flash
from ..forms.auth_forms import  LoginForm
from flask_login import login_required, login_user, logout_user, current_user, LoginManager
from . import professor
import requests, json
import datetime
from .auth import User

main = Blueprint('main', __name__, url_prefix='/')

@main.route('/')
def index():
    return redirect(url_for('professor.index')) #Redireccionar a función de vista

@main.route('/login', methods= ['POST'])
def login():
    loginForm = LoginForm()
    if loginForm.validate_on_submit():
        #Enviar requests
        data = '{"email":"'+loginForm.email.data+'", "password":"'+loginForm.password.data+'"}'
        r = requests.post(
            current_app.config["API_URL"]+'/auth/login',
            headers={"content-type":"application/json"},
            data = data)
        #Si la request se realiza con éxito
        if r.status_code == 200:
            #Cargar valores del usuario de la respuesta
            user_data = json.loads(r.text)
            user = User(id = user_data.get("id"), email = user_data.get("email"),  role = user_data.get("role") )
            #Loguear objeto usuario
            login_user(user)
            #Crear una request de redirección
            req = make_response(redirect(url_for('professor.index')))
            #Setear cookie con el valor del token
            req.set_cookie('access_token', user_data.get("access_token"), httponly = True)
            #Realizar la request
            return req
        else:
            #Mostrar error de autenticación
            flash('Usuario o contraseña incorrecta','danger')
    return redirect(url_for('professor.index'))

@main.route('/logout')
def logout():
    #Crear una request de redirección
    req = make_response(redirect(url_for('professor.index')))
    #Vaciar cookie
    req.set_cookie('access_token', '', httponly = True)
    #Deloguear usuario
    logout_user()
    #Realizar request
    return req

frontend/main/routes/professor.py
from flask import Blueprint, render_template, current_app, redirect, url_for
from ..forms.professor_form import ProfessorForm
from ..forms.auth_forms import  LoginForm
import requests, json

professor = Blueprint('professor', __name__, url_prefix='/professor')

@professor.route('/')
def index():
    r = requests.get(current_app.config["API_URL"]+'/professors',headers={"content-type":"application/json"})
    professors = json.loads(r.text)["professors"]
    title = "Professor - List"
    loginForm = LoginForm()
    return render_template('professor_list.html', title=title, professors=professors, loginForm = loginForm ) #Mostrar template

@professor.route('/view/<int:id>')
def view(id):
    r = requests.get(
        current_app.config["API_URL"]+'/professor/'+str(id),
        headers={"content-type":"application/json"})
    if(r.status_code==404):
        return redirect(url_for('professor.index'))
    professor = json.loads(r.text)
    title = "Professor - View"
    return render_template('professor_view.html', title=title, professor=professor  ) #Mostrar template

@professor.route('/create', methods=["POST","GET"])
def create():
    form = ProfessorForm() #Instanciar formulario
    if form.validate_on_submit(): #Si el formulario ha sido enviado y es validado correctamente
        return redirect(url_for('professor.index')) #Redirecciona a lista
    return render_template('professor_form.html', form = form) #Muestra el formulario

frontend/main/routes/project.py
from flask import Blueprint, render_template, current_app, redirect, url_for, request
from ..forms.project_form import ProjectForm
import requests, json
from flask_login import login_required, LoginManager
from ..forms.project_form import ProjectFilterForm
from .auth import admin_required
import io, csv
from flask import make_response

project = Blueprint('project', __name__, url_prefix='/project')

@project.route('/')
@login_required
def index():
    #Eliminar la protección csrf para el formulario de filtro
    #Cargar parametros de la url en el formulario
    filter = ProjectFilterForm(request.args,meta={'csrf': False})
    #Obtener profesores
    r = requests.get(
            current_app.config["API_URL"]+'/professors',
            headers={"content-type":"application/json"})
    #Cargar profesores en formulario
    professors = [(item['id'], item['lastname']+" "+item['firstname']) for item in json.loads(r.text)["professors"]]
    filter.professorId.choices = professors
    filter.professorId.choices.insert(0, [0,"All"])
    #Obtener token
    auth = request.cookies['access_token']
    #Crear headers
    headers = {
    'content-type': "application/json",
    'authorization': "Bearer "+auth
    }
    data = {}
    #Aplicado de filtros
    #Validar formulario
    if filter.validate() :
        if filter.yearFrom.data and filter.yearTo.data:
            if filter.yearFrom.data == filter.yearTo.data:
                data["year"] = filter.yearTo.data.year
        if filter.yearFrom.data != None:
            data["year[gte]"] = filter.yearFrom.data.year
        if filter.yearTo.data != None:
            data["year[lte]"] = filter.yearTo.data.year
        if filter.name.data != None:
            data["name"] = filter.name.data
        if filter.professorId.data != None and filter.professorId.data != 0:
            data["professorId"] = filter.professorId.data

    #Ordenamiento
    if 'sort_by' in request.args:
        data["sort_by"] = request.args.get('sort_by','')

    #Si se quiere descargar el archivo
    if 'download' in request.args:
        if request.args.get('download','') == 'Download':
            code = 200
            #Comenzar por la primera página
            page = 1
            list_projects = []
            #Recorrer hasta que no haya más páginas
            while code == 200:
                data['page'] = page
                #Llamada a la api
                r = requests.get(
                    current_app.config["API_URL"]+'/projects',
                    headers = headers,
                    data = json.dumps(data))
                code = r.status_code
                if(code==200):
                    #Recorrer los projectos de la página y colocar los campos que se quieren agregar
                    for project in json.loads(r.text)["projects"]:
                        element = {
                            'name': project["name"],
                            'professor': project["professor"]["firstname"]+" "+project["professor"]["lastname"],
                            'year': project["year"]
                        }
                        #Agregar cada elemento a la lista
                        list_projects.append(element)
                #Aumentar en uno el número de página
                page += 1

            #Inicializar para poder escribir en el buffer de memoria
            si = io.StringIO()
            #Inicializar el objeto que va a escribir el csv a partir de un diccionario
            #Pasar las claves del diccionario como cabecera
            fc = csv.DictWriter(si, fieldnames=list_projects[0].keys(),)
            #Escribir la cabecera
            fc.writeheader()
            #Escribir las filas
            fc.writerows(list_projects)

            #Crear una respuesta que tiene como contenido el valor del buffer
            output = make_response(si.getvalue())
            #Colocar cabeceras para que se descargue como un archivo
            output.headers["Content-Disposition"] = "attachment; filename=projects.csv"
            output.headers["Content-type"] = "text/csv"
            #Devolver salida
            return output

    #Número de página
    if 'page' in request.args:
        data["page"] = request.args.get('page','')
    else:
        if 'page' in data:
            del data["page"]

    #Obtener datos de la api para la tabla
    r = requests.get(
        current_app.config["API_URL"]+'/projects',
        headers = headers,
        data = json.dumps(data))

    if(r.status_code==200):
        #Cargar proyectos
        projects = json.loads(r.text)["projects"]
        #Cargar datos de paginación
        pagination = {}
        pagination["total"] = json.loads(r.text)["total"]
        pagination["pages"] = json.loads(r.text)["pages"]
        pagination["current_page"] = json.loads(r.text)["page"]
        title = "Project - List"
        return render_template('project_list.html', title=title, projects=projects, filter=filter, pagination = pagination  ) #Mostrar template
    else:
        return redirect(url_for('main.logout'))

@project.route('/view/<int:id>')
@login_required
def view(id):
    r = requests.get(current_app.config["API_URL"]+'/project/'+str(id),headers={"content-type":"application/json"})
    if(r.status_code==404):
        return redirect(url_for('project.index'))
    project = json.loads(r.text)
    title = "Project - View"
    return render_template('project_view.html', title=title, project=project  ) #Mostrar template

@project.route('/create', methods=["POST","GET"])
@login_required
@admin_required
def create():
    form = ProjectForm() #Instanciar formulario
    r = requests.get(
            current_app.config["API_URL"]+'/professors',
            headers={"content-type":"application/json"})
    professors = [(item['id'], item['lastname']+" "+item['firstname']) for item in json.loads(r.text)["professors"]]
    form.professorId.choices = professors
    if form.validate_on_submit(): #Si el formulario ha sido enviado y es validado correctamente
        auth = request.cookies['access_token']
        headers = {
        'content-type': "application/json",
        'authorization': "Bearer "+auth
        }
        data = {}
        data["name"] = form.name.data
        data["year"] = form.year.data.year
        data["professorId"] = form.professorId.data
        r = requests.post(
            current_app.config["API_URL"]+'/projects',
            headers = headers,
            data = json.dumps(data))
        if(r.status_code==201):
            return redirect(url_for('project.index')) #Redirecciona a lista
    return render_template('project_form.html', form = form) #Muestra el formulario

frontend/main/templates/form_macros.html
<!-- Macro que se encarga de mostrar los errores de validación -->
{% macro show_error(field) %}
	{% if field.errors %} <!--Si existen errores -->
	  <div class="alert alert-danger" role="alert">
	  {% for error in field.errors %} <!--Recorrer errrores-->
	   	{{ error }}<br><!--Mostrar error -->
	  {% endfor %}
	  </div>
	{% endif %}
{% endmacro %}

<!-- Macro que se encarga de mostrar los campos del formulario -->
{% macro show_field(field) %}
	{{ field.label }} <!-- Mostrar etiqueta -->
	{{ field(**kwargs)|safe }} <!-- Mostrar campo -->
	{{show_error(field)}}  <!-- Llamar a macro que muestra el error -->
{% endmacro %}

<!-- Macro que se encarga de mostrar los campos tipo submit formulario -->
{% macro show_submit(field) %}
	{{ field(**kwargs)|safe }} <!-- Mostrar campo -->
{% endmacro %}

frontend/main/templates/macros.html
<!-- Define la función para mostrar profesor -->
{% macro show_professor(professor) %}
<tr>
  <td>{{professor.id}}</td>
  <td>{{professor.firstname}}</td>
  <td>{{professor.lastname}}</td>
  <td>{{professor.email}}</td>
  <td>
    <a type="button" href="{{url_for('professor.view',id=professor.id)}}" class="btn btn-success">View</a>
    <a type="button" href="{{url_for('project.index',professorId=professor.id)}}" class="btn btn-success">View Projects</a>
  </td>
</tr>
{% endmacro %}

{% macro show_project(project) %}
<tr>
  <td>{{project.id}}</td>
  <td>{{project.name}}</td>
  <td>{{project.year}}</td>
  <td>{{project.professor.firstname}} {{project.professor.lastname}}</td>

</tr>
{% endmacro %}

frontend/main/templates/main.html
{% from "form_macros.html" import show_field, show_submit %}
<!DOCTYPE html>
<html lang="es">
	<head>
		<title>{{title}}</title>
		<meta charset="utf-8">
	<!--Colocar el viewport -->
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<!-- Incluir CDN CSS de Bootstrap-->
  {% block head %}
	<link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/css/bootstrap.min.css" integrity="sha384-9aIt2nRpC12Uk9gS9baDl411NQApFmC26EwAOH8WgZl5MYYxFfc+NcPb1dKGj7Sk" crossorigin="anonymous">
  {% endblock %}
  </head>
	<body>
  {% block menu %}
  <!-- Barra de navegacion -->
  <nav class="navbar fixed-top navbar-expand-md navbar-dark bg-dark">
    <a class="navbar-brand" href="#">Projects</a>
    <div class="collapse navbar-collapse" id="navbarSupportedContent">
      <ul class="navbar-nav mr-auto">
        <li class="nav-item active">
          <a class="nav-link" href="{{url_for('main.index')}}">Home <span class="sr-only">(actual)</span></a>
        </li>
        <li class="nav-item">
          <a class="nav-link" href="{{url_for('professor.index')}}">Professor</a>
        </li>
				<li class="nav-item">
					<a class="nav-link" href="{{url_for('project.index')}}">Project</a>
				</li>
				<li style="margin-left:450px;color:white">
				{% if current_user.is_authenticated %}
					<span style="margin-right:10px">Hola {{current_user.email}}</span><a href="{{ url_for('main.logout') }}" class="btn btn-secondary">Logout</a>
				{% else %}
					<form method="POST" action="{{ url_for('main.login') }}" >
						<input type="hidden" name="csrf_token" value="{{ csrf_token() }}"/>
						<div class="form-row">
							<div class="form-group col-md-5">
									{{ show_field(loginForm.email, class='form-control' )}}
							</div>
							<div class="form-group col-md-5">
									{{ show_field(loginForm.password , class='form-control')}}
							</div>
							<div class="form-group col-md-2" style="margin-top:30px">
								{{ show_submit(loginForm.submit , class='btn btn-success')}}
							</div>
						</div>
					</form>
				{% endif %}
				</li>
				</ul>
      </div>
  </nav>
  {% endblock %}
  <br/><br/><br/><br/><br/><br/>
	<div class="container">
   <div class="row">
     <div class="col-md-12">
      {% with messages = get_flashed_messages(with_categories=true) %}
        {% if messages %}
          {% for category, message in messages %}
            <div class="alert alert-{{category}} alert-dismissible fade show" role="alert">
              {{ message }}
              <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                <span aria-hidden="true">&times;</span>
              </button>
            </div>
          {% endfor %}
         {% endif %}
      {% endwith %}
    </div>
  </div>
</div>
  {% block content %}
	{% endblock %}

  {% block scripts %}
	<!-- Incluir CDN Jquery-->
	<script src="https://code.jquery.com/jquery-3.5.1.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
	<!-- Incluir CDN Popper-->
	<script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.0/dist/umd/popper.min.js" integrity="sha384-Q6E9RHvbIyZFJoft+2mJbHaEWldlvI9IOYy5n3zV9zzTtmI3UksdQRVvoxMfooAo" crossorigin="anonymous"></script>
	<!-- Incluir CDN Js de Bootstrap-->
	<script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/js/bootstrap.min.js" integrity="sha384-OgVRvuATP1z7JjHLkuOU7Xw704+h835Lr+6QL9UvYjZE3Ipu6Tp75j7Bh/kR0JKI" crossorigin="anonymous"></script>
  {% endblock %}
  </body>
</html>

frontend/main/templates/professor_form.html
<!-- Hereda de el template main -->
{% extends 'main.html'%}  {# Herencia #}
<!-- Importar macro -->
{% import 'macros.html' as macro %}

<!--Hereda el bloque de cabecera manteniendo su contenido con la función super() y agregando el link a la hoja de estilo al final del mismo -->
{% block head %}
    {{ super() }} {# Heredar el contenido del bloque bloque #}
    <link rel="stylesheet" href="{{url_for('static', filename='css/style.css')}}"> {# Nuevo contenido del bloque #}
{% endblock %}

{% from "form_macros.html" import show_field, show_submit %}

<!-- Comienza el bloque de contenido y define su contenido -->
{% block content %}

<div class="container">
  <div class="row">
    <div class="col-md-12">
	    <form method="POST" action="{{ url_for('professor.create') }}" >
	      <input type="hidden" name="csrf_token" value="{{ csrf_token() }}"/>
	     	<div class="form-row">
	    		<div class="form-group col-md-6">
	      			{{ show_field(form.firstname, class='form-control' )}}
	    		</div>
	    		<div class="form-group col-md-6">
	      			{{ show_field(form.lastname , class='form-control')}}
	    		</div>
	  		</div>
	  		<div class="form-row">
	    		<div class="form-group col-md-4">
	      			{{ show_field(form.email , class='form-control')}}
	      	</div>
          <div class="form-group col-md-4">
            {{ show_field(form.password , class='form-control')}}
          </div>
          <div class="form-group col-md-4">
            {{ show_field(form.confirm , class='form-control')}}
          </div>
	  		</div>
	  	  <!--Llama a macro especial para mostrar el campo de submit -->
	 			{{ show_submit(form.submit , class='btn btn-success')}}
	  	</form>
  	</div>
  </div>
</div>
{% endblock%}

frontend/main/templates/professor_list.html
<!-- Hereda de el template main -->
{% extends 'main.html'%}  {# Herencia #}
<!-- Importar macro -->
{% import 'macros.html' as macro %}

<!--Hereda el bloque de cabecera manteniendo su contenido con la función super() y agregando el link a la hoja de estilo al final del mismo -->
{% block head %}
    {{ super() }} {# Heredar el contenido del bloque bloque #}
    <link rel="stylesheet" href="{{url_for('static', filename='css/style.css')}}"> {# Nuevo contenido del bloque #}
{% endblock %}

<!-- Comienza el bloque de contenido y define su contenido -->
{% block content %}
		<div class="container-fluid">
		<div class="row">
				<div class="col-md-12 ">
					<h2>{{title}}</h2>
				</div>
		  </div>
		 	<div class="row">
				<!--Columna -->
				<div class="col-md-12 ">
          <a type="button" href="{{url_for('professor.create')}}" class="btn btn-success">Create</a>
          <table class="table table-bordered table-dark">
						<tr>
							<th>#</th>
              <th>Firstname</th>
              <th>Lastname</th>
              <th>Email</th>
              <th></th>
						</tr>
						{% for professor in professors %}
						    {{ macro.show_professor(professor) }}
						{% endfor %}
					</table>
				</div>
		</div><!--Fin de la fila -->
  </div><!-- Fin del contenedor -->
{% endblock %}

frontend/main/templates/professor_view.html
<!-- Hereda de el template main -->
{% extends 'main.html'%}  {# Herencia #}
<!-- Comienza el bloque de contenido y define su contenido -->
{% block content %}
	<div class="container-fluid">
		<div class="row">
				<div class="col-md-12 ">
						<h2>{{title}}</h2>
				</div>
		  </div>
		 	<div class="row">
				<!--Columna -->
				<div class="col-md-12 ">
					<div class="card" style="width:20%">
						<img src="{{url_for('static', filename='img/user.png')}}" class="card-img-top" alt="User image">
							<ul class="list-group list-group-flush">
								<li class="list-group-item"><b>Firstname: </b>{{professor.firstname}}</li>
								<li class="list-group-item"><b>Lastname: </b>{{professor.lastname}}</li>
								<li class="list-group-item"><b>E-mail: </b>{{professor.email}}</li>
							</ul>
						</div>
				</div>
		</div><!--Fin de la fila -->
  </div><!-- Fin del contenedor -->
{% endblock %}

frontend/main/templates/project_form.html
<!-- Hereda de el template main -->
{% extends 'main.html'%}  {# Herencia #}
<!-- Importar macro -->
{% import 'macros.html' as macro %}

<!--Hereda el bloque de cabecera manteniendo su contenido con la función super() y agregando el link a la hoja de estilo al final del mismo -->
{% block head %}
    {{ super() }} {# Heredar el contenido del bloque bloque #}
    <link rel="stylesheet" href="{{url_for('static', filename='css/style.css')}}"> {# Nuevo contenido del bloque #}
{% endblock %}

{% from "form_macros.html" import show_field, show_submit %}

<!-- Comienza el bloque de contenido y define su contenido -->
{% block content %}

<div class="container">
  <div class="row">
    <div class="col-md-12">
	    <form method="POST" action="{{ url_for('project.create') }}" >
	      <input type="hidden" name="csrf_token" value="{{ csrf_token() }}"/>
	     	<div class="form-row">
	    		<div class="form-group col-md-4">
	      			{{ show_field(form.name, class='form-control' )}}
	    		</div>
	    		<div class="form-group col-md-4">
	      			{{ show_field(form.year , class='form-control')}}
	    		</div>
          <div class="form-group col-md-4">
	      			{{ show_field(form.professorId , class='form-control')}}
	    		</div>
	  		</div>
	  		  <!--Llama a macro especial para mostrar el campo de submit -->
	 			{{ show_submit(form.submit , class='btn btn-success')}}
	  	</form>
  	</div>
  </div>
</div>
{% endblock%}

frontend/main/templates/project_list.html
<!-- Hereda de el template main -->
{% extends 'main.html'%}  {# Herencia #}
<!-- Importar macro -->
{% import 'macros.html' as macro %}

<!--Hereda el bloque de cabecera manteniendo su contenido con la función super() y agregando el link a la hoja de estilo al final del mismo -->
{% block head %}
    {{ super() }} {# Heredar el contenido del bloque bloque #}
    <link rel="stylesheet" href="{{url_for('static', filename='css/style.css')}}"> {# Nuevo contenido del bloque #}
{% endblock %}

<!-- Comienza el bloque de contenido y define su contenido -->
{% block content %}
		<div class="container-fluid">
		<div class="row">
				<div class="col-md-12 ">
					<h2>{{title}}</h2>
				</div>
		  </div>
      <div class="row">
        <div class="col-md-12">
          <form method="GET" action="{{ url_for('project.index') }}" >
            <div class="form-row">
              <div class="form-group col-md-3">
                  {{ show_field(filter.name, class='form-control' )}}
              </div>
              <div class="form-group col-md-1">
                  {{ show_field(filter.yearFrom , class='form-control')}}
              </div>
              <div class="form-group col-md-1">
                  {{ show_field(filter.yearTo , class='form-control')}}
              </div>
              <div class="form-group col-md-3">
                  {{ show_field(filter.professorId , class='form-control')}}
              </div>
              <div class="form-group col-md-2" style="margin-top:30px">
                {{ show_submit(filter.submit , class='btn btn-success')}}
                {{ show_submit(filter.download , class='btn btn-success')}}
              </div>
            </div>
          </form>
        </div>
      </div>
		 	<div class="row">
      <!--Columna -->
				<div class="col-md-6 ">
          <a type="button" href="{{url_for('project.create')}}" class="btn btn-success" >Create</a>
        <!-- Mostrar cantidad total de elementos para los filtros aplicados -->
         Total: {{pagination.total}}
       </div>
       <div class="col-md-6 ">
         <!-- Mostrar paginación -->
          <nav aria-label="Pagination">
              <ul class="pagination justify-content-end">
              <!-- Boton de página anterior, desactivar si se está en la primera página -->
              {% if pagination.current_page != 1 %}
              <li class="page-item">
                <a class="page-link"
                 href="{{ url_for('project.index',
                      page = (pagination.current_page-1),
                      sort_by = request.args.sort_by,
                      name = request.args.name,
                      professorId =request.args.professorId,
                      yearFrom = request.args.yearFrom,
                      yearTo = request.args.yearTo ) }}" >Previous</a>
              </li>
              {% else %}
              <li class="page-item disabled">
                <a class="page-link" href="#" tabindex="-1" aria-disabled="true">Previous</a>
              </li>
              {% endif %}
              <!-- Recorrer cantidad de páginas para el filtrado actual -->
              {% for n in range(1,pagination.pages+1) %}
                    <!-- Boton para cada página, desactivar para página actual -->
                   {% if n != pagination.current_page %}
                        <li class="page-item">
                          <a class="page-link" href="{{ url_for('project.index',
                               page = n,
                               sort_by = request.args.sort_by,
                               name = request.args.name,
                               professorId =request.args.professorId,
                               yearFrom = request.args.yearFrom,
                               yearTo = request.args.yearTo ) }}">{{n}}</a>
                        </li>
                   {% else %}
                       <li class="page-item disabled">
                           <a class="page-link" href="#" tabindex="-1" aria-disabled="true">{{n}}</a>
                       </li>
                   {% endif %}
              {% endfor %}
               <!-- Boton de página siguiente, desactivar si se está en la última página -->
              {% if pagination.current_page != pagination.pages %}
              <li class="page-item">
                <a class="page-link"
                href="{{ url_for('project.index',
                     page = (pagination.current_page+1),
                     sort_by = request.args.sort_by,
                     name = request.args.name,
                     professorId =request.args.professorId,
                     yearFrom = request.args.yearFrom,
                     yearTo = request.args.yearTo ) }}" >Next</a>
              </li>
              {% else %}
              <li class="page-item disabled">
                <a class="page-link" href="#" tabindex="-1" aria-disabled="true">Next</a>
              </li>
              {% endif %}
              </li>
            </ul>
          </nav>
        </div>
      </div>
      <div class="row">
        <div class="col-md-12">
          <table class="table table-bordered table-dark">
						<tr>
							<th>#</th>
              <th>
                <!-- Botones de ordenamiento -->
                <!-- Si ya se está filtrando de manera ascendente para este campo bostrar boton para descendente -->
                {% if request.args.sort_by == "name.desc"  %}
                <a href="{{ url_for('project.index',
                     sort_by = 'name',
                     name = request.args.name,
                     professorId =request.args.professorId,
                     yearFrom = request.args.yearFrom,
                     yearTo = request.args.yearTo ) }}" >Name</a>
                {% else %}
                <a  href="{{ url_for('project.index',
                          sort_by = 'name.desc',
                          name = request.args.name,
                          professorId =request.args.professorId,
                          yearFrom = request.args.yearFrom,
                          yearTo = request.args.yearTo ) }}" >Name</a>
                {% endif %}

              </th>
              <th>
                {% if request.args.sort_by == "year.desc"  %}
                  <a href="{{ url_for('project.index',
                       sort_by = 'year',
                       name = request.args.name,
                       professorId =request.args.professorId,
                       yearFrom = request.args.yearFrom,
                       yearTo = request.args.yearTo ) }}" >Year</a>
                  {% else %}
                  <a  href="{{ url_for('project.index',
                            sort_by = 'year.desc',
                            name = request.args.name,
                            professorId =request.args.professorId,
                            yearFrom = request.args.yearFrom,
                            yearTo = request.args.yearTo ) }}" >Year</a>
                  {% endif %}
              </th>
              <th>
                {% if request.args.sort_by == "professor.desc"  %}
                <a href="{{ url_for('project.index',
                     sort_by = 'professor',
                     name = request.args.name,
                     professorId =request.args.professorId,
                     yearFrom = request.args.yearFrom,
                     yearTo = request.args.yearTo ) }}" >Professor</a>
                {% else %}
                <a  href="{{ url_for('project.index',
                          sort_by = 'professor.desc',
                          name = request.args.name,
                          professorId =request.args.professorId,
                          yearFrom = request.args.yearFrom,
                          yearTo = request.args.yearTo ) }}" >Professor</a>
                {% endif %}
              </th>

						</tr>
						{% for project in projects %}
						    {{ macro.show_project(project) }}
						{% endfor %}
					</table>
				</div>
		</div><!--Fin de la fila -->
  </div><!-- Fin del contenedor -->
{% endblock %}